// player.cpp -	Contains functions for the player class.
// Name: 			Lawrence Bush
// RCS Account:		bushl2
// Student Number:	074640477
// Section: 		1
// Email: 			Lawrence_Bush@dps.state.ny.us

// Project 4
// _________________________________________ 
#include <iostream>
#include <iomanip>


#include "player.h"
using namespace std;

const std::string NULL_STRING = "";

// Constructor - assigns all player attributes
player::player( string name_in,const char position_in,const int FT_in,
			   const int IN_in,	int WT_in,	float PTS_in,float REB_in,
			   float AST_in,int REQ_SALARY_in,float RATING_in )
			   : name( name_in ),position(position_in),FT(FT_in), IN(IN_in),
			   WT(WT_in),PTS(PTS_in),REB(REB_in),AST(AST_in),REQ_SALARY(REQ_SALARY_in),
			   RATING(RATING_in) 
{	// get rid of ; at end of name
	name.replace(name.find_last_of(";"), 1,"");
	// compute value
	value = (RATING_in*1000000)/REQ_SALARY_in;//rating points per million $
}
//**********************************************************
// Overloaded non-member << operator	
//**********************************************************
std::ostream &
operator << ( std::ostream & outstr,
			 const player & p )
{	
	outstr <<p.get_name();
	for(int i=p.get_name().length();i<17;i++) {outstr<<" ";}
	// this funny syntax is to format the table to the appropriate 
	// number of significant digits, and allign the columns etc.
	outstr<<"  " <<setiosflags(ios::showpoint)<<setprecision(3)<< p.get_position()<<"  "<<p.get_FT()<<"ft"<<setw(3)<<p.get_IN()<<"in"<<"  "<< p.get_WT()<<" "<<setw(7)<<setprecision(1)<<setiosflags(ios::fixed | ios::showpoint)<<p.get_PTS()<<" "<<setw(7)<<setprecision(1)<<p.get_REB()<<" "<< setw(7)<<p.get_AST()<<""<<setw(10)<<p.get_salary()<<" "<< setw(6)<<setprecision(2)<<p.get_rating()<< endl;
	
	return outstr;
}

