//
// File:  team.h

// Name: 			Lawrence Bush
// RCS Account:		bushl2
// Student Number:	074640477
// Section: 		1
// Email: 			Lawrence_Bush@dps.state.ny.us

// Project 4
// _________________________________________ 
// Purpose: Declare a class to store a vector of players.
//
//			Contains a team class.
//			Stores a vector of players (team) that are
//			inserted (hire) from the draft_list.
//			Performs various functions on the team such
//			as hire, cut, criteria (does team meet criteria),
//			print.
//

#ifndef _team_h_
#define _team_h_


#include <string>

#include <vector>
#include "player.h"
using namespace std;

// class name
class team {
	
public:
	team(int salary_cap_in=0);  // default constructor 
	team(const team & t); // copy constructor
	bool hire(player trade); // (hire) insert a player object into the container
	cut();// remove a player object from the container
	int size() const { return roster.size(); }// returns the size of the vector using ths STL size function.
	
	void print(ostream out);// print function to print whole team
	float rating() {return team_rating;}// get function for team rating
	int salary() {return total_salary;}//get function for team salary
	int get_salary_cap() {return salary_cap;} // get function to return salary cap
	bool criteria();// unary function that tests if the team meets specified criteria
	//*********************
	// Overloaded Operators
	//*********************
	player operator[](int k) const;// assessor operator, returns player k
	bool operator<( const team & rhs) const; // binary comparitor of team.rating
	const team & operator=(const team & rhs); // assignment operator
	
	
private:
	// private data members
	vector<player> roster; //STL vector that holds the team players
	string name;// the cheap dream team
	int guards; // min 4 // tracks the number of grards hired 
	int centers; // min 1 // tracks the number of centers hired
	int forwards; // min 3 // tracks the number of forwards hired
	
	int total_salary;// tracks the team salary
	int salary_cap;// stores the salary cap specified by the command line argument
	float team_rating; // tracks and stores the rating of the team
	int team_size; // tracks the team size (number of players in the team)
};


#endif
